Index: boot/arch/arm32/include/types.h
===================================================================
--- boot/arch/arm32/include/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/include/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,6 @@
 #define BOOT_arm32_TYPES_H
 
+#include <arch/common.h>
+
 #define TASKMAP_MAX_RECORDS        32
 #define BOOTINFO_TASK_NAME_BUFLEN  32
Index: boot/arch/arm32/src/main.c
===================================================================
--- boot/arch/arm32/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,4 @@
 #include <arch/asm.h>
 #include <arch/mm.h>
-#include <arch/_components.h>
 #include <halt.h>
 #include <printf.h>
@@ -44,8 +43,10 @@
 #include <macros.h>
 #include <align.h>
+#include <stdbool.h>
 #include <str.h>
 #include <errno.h>
 #include <inflate.h>
 #include <arch/cp15.h>
+#include "../../components.h"
 
 #define TOP2ADDR(top)  (((void *) PA2KA(BOOT_OFFSET)) + (top))
@@ -98,6 +99,6 @@
 	
 	for (size_t i = 0; i < COMPONENTS; i++) {
-		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
-		    components[i].start, components[i].name, components[i].inflated,
+		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].addr,
+		    components[i].addr, components[i].name, components[i].inflated,
 		    components[i].size);
 	}
@@ -128,5 +129,5 @@
 	
 	for (size_t i = cnt; i > 0; i--) {
-		void *tail = components[i - 1].start + components[i - 1].size;
+		void *tail = components[i - 1].addr + components[i - 1].size;
 		if (tail >= dest[i - 1]) {
 			printf("\n%s: Image too large to fit (%p >= %p), halting.\n",
@@ -137,5 +138,5 @@
 		printf("%s ", components[i - 1].name);
 		
-		int err = inflate(components[i - 1].start, components[i - 1].size,
+		int err = inflate(components[i - 1].addr, components[i - 1].size,
 		    dest[i - 1], components[i - 1].inflated);
 		if (err != EOK) {
Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/src/mm.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
  */
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <arch/asm.h>
 #include <arch/mm.h>
Index: boot/arch/arm32/src/putchar.c
===================================================================
--- boot/arch/arm32/src/putchar.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/src/putchar.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,8 @@
  */
 
-#include <typedefs.h>
 #include <arch/main.h>
 #include <putchar.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <str.h>
 
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,6 @@
 	arch/$(BARCH)/src/pal_asm.S \
 	arch/$(BARCH)/src/putchar.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	genarch/src/efi.c \
 	genarch/src/division.c \
@@ -88,2 +89,3 @@
 	bus/isa
 
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/ia64/_link.ld.in
===================================================================
--- boot/arch/ia64/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -16,7 +16,7 @@
 		*(.bss);                /* uninitialized static variables */
 		*(COMMON);
-[[COMPONENTS]]
+		*(.components);
 	}
-
+	
 	/DISCARD/ : {
 		*(.*);
Index: boot/arch/ia64/include/pal.h
===================================================================
--- boot/arch/ia64/include/pal.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/include/pal.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,6 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
+#include <stddef.h>
+#include <stdint.h>
 
 /*
Index: boot/arch/ia64/include/sal.h
===================================================================
--- boot/arch/ia64/include/sal.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/include/sal.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,6 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
+#include <stddef.h>
+#include <stdint.h>
 
 /*
Index: boot/arch/ia64/include/ski.h
===================================================================
--- boot/arch/ia64/include/ski.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/include/ski.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,5 @@
 #define BOOT_ia64_SKI_H_
 
+#include <stddef.h>
 #include <str.h>
 
Index: boot/arch/ia64/src/main.c
===================================================================
--- boot/arch/ia64/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,4 @@
 #include <arch/arch.h>
 #include <arch/asm.h>
-#include <arch/_components.h>
 #include <genarch/efi.h>
 #include <arch/sal.h>
@@ -46,4 +45,5 @@
 #include <errno.h>
 #include <inflate.h>
+#include "../../components.h"
 
 #define DEFAULT_MEMORY_BASE		0x4000000ULL
@@ -78,5 +78,5 @@
 		memmap[items].size = DEFAULT_LEGACY_IO_SIZE;
 		memmap[items].type = MEMMAP_IO_PORTS;
-		items++;		 
+		items++;
 	} else {
 		char *cur, *mm_base = (char *) bootpar->efi_memmap;
@@ -159,6 +159,6 @@
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
-		    components[i].start, components[i].name,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].addr,
+		    components[i].addr, components[i].name,
 		    components[i].inflated, components[i].size);
 	
@@ -202,5 +202,5 @@
 		 * overlap with the destination for inflate().
 		 */
-		memmove((void *) top, components[i - 1].start, components[i - 1].size);
+		memmove((void *) top, components[i - 1].addr, components[i - 1].size);
 		
 		int err = inflate((void *) top, components[i - 1].size,
Index: boot/arch/ia64/src/putchar.c
===================================================================
--- boot/arch/ia64/src/putchar.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/src/putchar.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,7 +27,7 @@
  */
 
-#include <typedefs.h>
 #include <arch/arch.h>
 #include <putchar.h>
+#include <stddef.h>
 #include <str.h>
 #include <arch/ski.h>
Index: boot/arch/ia64/src/ski.c
===================================================================
--- boot/arch/ia64/src/ski.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ia64/src/ski.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,6 @@
 
 #include <arch/ski.h>
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 
 #define SKI_INIT_CONSOLE	20
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/mips32/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,5 @@
 BITS = 32
 EXTRA_CFLAGS = -msoft-float -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mabi=32
+AS_PROLOG = .module softfloat;
 
 ifeq ($(MACHINE),msim)
@@ -74,5 +75,6 @@
 	arch/$(BARCH)/src/main.c \
 	arch/$(BARCH)/src/putchar.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	genarch/src/division.c \
 	genarch/src/multiplication.c \
@@ -84,2 +86,4 @@
 	generic/src/version.c \
 	generic/src/inflate.c
+
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/mips32/_link.ld.in
===================================================================
--- boot/arch/mips32/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/mips32/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -21,5 +21,5 @@
 		*(.bss);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-[[COMPONENTS]]
+		*(.components);
 	}
 	
Index: boot/arch/mips32/include/types.h
===================================================================
--- boot/arch/mips32/include/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/mips32/include/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,6 @@
 #define BOOT_mips32_TYPES_H_
 
+#include <arch/common.h>
+
 #define TASKMAP_MAX_RECORDS        32
 #define CPUMAP_MAX_RECORDS         32
Index: boot/arch/mips32/src/main.c
===================================================================
--- boot/arch/mips32/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/mips32/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,4 @@
 #include <arch/arch.h>
 #include <arch/asm.h>
-#include <arch/_components.h>
 #include <halt.h>
 #include <printf.h>
@@ -40,4 +39,5 @@
 #include <errno.h>
 #include <inflate.h>
+#include "../../components.h"
 
 #define TOP2ADDR(top)  (((void *) PA2KA(BOOT_OFFSET)) + (top))
@@ -64,8 +64,8 @@
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
-		    (uintptr_t) components[i].start >= PA2KSEG(0) ?
-		    (void *) KSEG2PA(components[i].start) :
-		    (void *) KA2PA(components[i].start),
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].addr,
+		    (uintptr_t) components[i].addr >= PA2KSEG(0) ?
+		    (void *) KSEG2PA(components[i].addr) :
+		    (void *) KA2PA(components[i].addr),
 		    components[i].name, components[i].inflated,
 		    components[i].size);
@@ -107,5 +107,5 @@
 		printf("%s ", components[i - 1].name);
 		
-		int err = inflate(components[i - 1].start, components[i - 1].size,
+		int err = inflate(components[i - 1].addr, components[i - 1].size,
 		    dest[i - 1], components[i - 1].inflated);
 		
Index: boot/arch/mips32/src/putchar.c
===================================================================
--- boot/arch/mips32/src/putchar.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/mips32/src/putchar.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,5 +27,6 @@
  */
 
-#include <typedefs.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <arch/arch.h>
 #include <putchar.h>
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,4 +44,5 @@
 RD_DRVS_ESSENTIAL += \
 	platform/mac \
+	bus/adb/cuda_adb \
 	bus/pci/pciintel \
 	bus/usb/ohci \
@@ -57,5 +58,6 @@
 	arch/$(BARCH)/src/main.c \
 	arch/$(BARCH)/src/ofw.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	genarch/src/ofw.c \
 	genarch/src/ofw_tree.c \
@@ -70,2 +72,4 @@
 	generic/src/version.c \
 	generic/src/inflate.c
+
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/ppc32/_link.ld.in
===================================================================
--- boot/arch/ppc32/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -18,5 +18,5 @@
 		*(.bss);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-[[COMPONENTS]]
+		*(.components);
 	}
 	
Index: boot/arch/ppc32/include/asm.h
===================================================================
--- boot/arch/ppc32/include/asm.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/include/asm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_ppc32_ASM_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <arch/main.h>
 
Index: boot/arch/ppc32/include/main.h
===================================================================
--- boot/arch/ppc32/include/main.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/include/main.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_ppc32_MAIN_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <balloc.h>
 #include <genarch/ofw_tree.h>
Index: boot/arch/ppc32/include/types.h
===================================================================
--- boot/arch/ppc32/include/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/include/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,6 @@
 #define BOOT_ppc32_TYPES_H_
 
+#include <arch/common.h>
+
 #define TASKMAP_MAX_RECORDS        32
 #define BOOTINFO_TASK_NAME_BUFLEN  32
Index: boot/arch/ppc32/src/main.c
===================================================================
--- boot/arch/ppc32/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,4 @@
 #include <arch/arch.h>
 #include <arch/asm.h>
-#include <arch/_components.h>
 #include <genarch/ofw.h>
 #include <genarch/ofw_tree.h>
@@ -42,4 +41,5 @@
 #include <errno.h>
 #include <inflate.h>
+#include "../../components.h"
 
 #define BALLOC_MAX_SIZE  131072
@@ -75,6 +75,6 @@
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
-		    ofw_translate(components[i].start), components[i].name,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].addr,
+		    ofw_translate(components[i].addr), components[i].name,
 		    components[i].inflated, components[i].size);
 	
@@ -139,5 +139,5 @@
 		printf("%s ", components[i - 1].name);
 		
-		int err = inflate(components[i - 1].start, components[i - 1].size,
+		int err = inflate(components[i - 1].addr, components[i - 1].size,
 		    inflate_base + dest[i - 1], components[i - 1].inflated);
 		
Index: boot/arch/ppc32/src/ofw.c
===================================================================
--- boot/arch/ppc32/src/ofw.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/ppc32/src/ofw.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,5 @@
 
 #include <genarch/ofw.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <putchar.h>
 #include <str.h>
Index: boot/arch/riscv64/Makefile.inc
===================================================================
--- boot/arch/riscv64/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
 BITS = 64
 ENDIANESS = LE
+EXTRA_CFLAGS = -mcmodel=medany
 
 SOURCES = \
@@ -40,5 +41,6 @@
 	arch/$(BARCH)/src/ucb.c \
 	arch/$(BARCH)/src/putchar.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	generic/src/memstr.c \
 	generic/src/printf_core.c \
@@ -48,2 +50,4 @@
 	generic/src/version.c \
 	generic/src/inflate.c
+
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/riscv64/_link.ld.in
===================================================================
--- boot/arch/riscv64/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -1,9 +1,27 @@
+#include <arch/arch.h>
+
 ENTRY(start)
 
 SECTIONS {
+	. = PHYSMEM_START;
+	
 	.text : {
 		*(BOOTSTRAP);
 		*(.text);
 	}
+	
+	. = ALIGN(0x1000);
+	.htif : {
+		htif_page = .;
+		*(.htif)
+	}
+	. = ALIGN(0x1000);
+	
+	. = ALIGN(0x1000);
+	.pt : {
+		pt_page = .;
+		*(.pt)
+	}
+	. = ALIGN(0x1000);
 	
 	.data : {
@@ -17,5 +35,5 @@
 		*(.bss);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-[[COMPONENTS]]
+		*(.components);
 	}
 	
Index: boot/arch/riscv64/include/arch.h
===================================================================
--- boot/arch/riscv64/include/arch.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/include/arch.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,8 @@
 #define BOOT_STACK_SIZE  PAGE_SIZE
 
+#define PHYSMEM_START  0x40000000
+#define PHYSMEM_SIZE   1073741824
+#define BOOT_OFFSET    0x48000000
+
 #define DEFAULT_MTVEC      0x00000100
 #define TRAP_VECTOR_RESET  0x0100
Index: boot/arch/riscv64/include/asm.h
===================================================================
--- boot/arch/riscv64/include/asm.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/include/asm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,7 +30,10 @@
 #define BOOT_riscv64_ASM_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
-extern void jump_to_kernel(void *, uintptr_t)
+extern char htif_page[];
+extern char pt_page[];
+
+extern void jump_to_kernel(uintptr_t)
     __attribute__((noreturn));
 
Index: boot/arch/riscv64/include/mm.h
===================================================================
--- boot/arch/riscv64/include/mm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ boot/arch/riscv64/include/mm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2017 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#ifndef BOOT_riscv64_MM_H_
+#define BOOT_riscv64_MM_H_
+
+#ifndef __ASM__
+	#define KA2PA(x)  (((uintptr_t) (x)) - UINT64_C(0xffff800000000000))
+	#define PA2KA(x)  (((uintptr_t) (x)) + UINT64_C(0xffff800000000000))
+#else
+	#define KA2PA(x)  ((x) - 0xffff800000000000)
+	#define PA2KA(x)  ((x) + 0xffff800000000000)
+#endif
+
+#define PTL_DIRTY       (1 << 7)
+#define PTL_ACCESSED    (1 << 6)
+#define PTL_GLOBAL      (1 << 5)
+#define PTL_USER        (1 << 4)
+#define PTL_EXECUTABLE  (1 << 3)
+#define PTL_WRITABLE    (1 << 2)
+#define PTL_READABLE    (1 << 1)
+#define PTL_VALID       1
+
+#endif
+
+/** @}
+ */
Index: boot/arch/riscv64/include/types.h
===================================================================
--- boot/arch/riscv64/include/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/include/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,6 @@
 #define BOOT_riscv64_TYPES_H_
 
+#include <arch/common.h>
+
 #define MEMMAP_MAX_RECORDS         32
 #define TASKMAP_MAX_RECORDS        32
@@ -38,4 +40,9 @@
 
 typedef int64_t ptrdiff_t;
+
+typedef struct {
+	volatile uint64_t *tohost;
+	volatile uint64_t *fromhost;
+} ucbinfo_t;
 
 typedef struct {
@@ -65,4 +72,8 @@
 
 typedef struct {
+	ucbinfo_t ucbinfo;
+	uintptr_t physmem_start;
+	uintptr_t htif_frame;
+	uintptr_t pt_frame;
 	memmap_t memmap;
 	taskmap_t taskmap;
Index: boot/arch/riscv64/include/ucb.h
===================================================================
--- boot/arch/riscv64/include/ucb.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/include/ucb.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,8 +36,8 @@
  */
 
-#include <typedefs.h>
+#include <stddef.h>
 
-#define CSR_MTOHOST    0x780
-#define CSR_MFROMHOST  0x781
+extern volatile uint64_t tohost;
+extern volatile uint64_t fromhost;
 
 #define HTIF_DEVICE_CONSOLE  1
Index: boot/arch/riscv64/src/asm.S
===================================================================
--- boot/arch/riscv64/src/asm.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/src/asm.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -29,4 +29,23 @@
 #include <abi/asmtool.h>
 #include <arch/arch.h>
+#include <arch/mm.h>
+
+#define MCOUNTEREN_CY_MASK  0x00000001
+#define MCOUNTEREN_TM_MASK  0x00000002
+#define MCOUNTEREN_IR_MASK  0x00000004
+
+#define MSTATUS_MPP_MASK        0x00001800
+#define MSTATUS_MPP_USER        0x00000000
+#define MSTATUS_MPP_SUPERVISOR  0x00000800
+#define MSTATUS_MPP_MACHINE     0x00001800
+
+#define MSTATUS_SUM_MASK        0x00040000
+
+#define SATP_PFN_MASK  0x00000fffffffffff
+
+#define SATP_MODE_MASK  0xf000000000000000
+#define SATP_MODE_BARE  0x0000000000000000
+#define SATP_MODE_SV39  0x8000000000000000
+#define SATP_MODE_SV48  0x9000000000000000
 
 .section BOOTSTRAP
@@ -76,5 +95,38 @@
 
 FUNCTION_BEGIN(jump_to_kernel)
-	j halt
+	/* Enable performance counters access in supervisor mode */
+	csrsi mcounteren, MCOUNTEREN_CY_MASK | MCOUNTEREN_TM_MASK | MCOUNTEREN_IR_MASK
+	
+	/* Setup SV48 paging for supervisor mode */
+	la t0, ptl_0
+	srli t0, t0, 12
+	
+	li t1, SATP_PFN_MASK
+	and t0, t0, t1
+	
+	li t1, SATP_MODE_SV48
+	or t0, t0, t1
+	
+	csrw sptbr, t0
+	
+	/* Jump to supervisor mode */
+	csrr t0, mstatus
+	
+	li t1, ~MSTATUS_MPP_MASK
+	and t0, t0, t1
+	
+	/*
+	 * TODO: Enable running with Supervisor User Mode
+	 * access disabled.
+	 */
+	li t1, MSTATUS_MPP_SUPERVISOR | MSTATUS_SUM_MASK
+	or t0, t0, t1
+	
+	csrw mstatus, t0
+	
+	li ra, PA2KA(BOOT_OFFSET)
+	csrw mepc, ra
+	
+	mret
 FUNCTION_END(jump_to_kernel)
 
@@ -88,2 +140,11 @@
 SYMBOL(boot_stack)
 	.space BOOT_STACK_SIZE
+
+.section .pt, "aw", @progbits
+
+.align PAGE_WIDTH
+SYMBOL(ptl_0)
+	.fill 256, 8, 0
+	/* Identity mapping for [0; 512G) */
+	.quad 0 + (PTL_DIRTY | PTL_ACCESSED | PTL_EXECUTABLE | PTL_WRITABLE | PTL_READABLE | PTL_VALID)
+	.fill 255, 8, 0
Index: boot/arch/riscv64/src/main.c
===================================================================
--- boot/arch/riscv64/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,6 +30,8 @@
 #include <arch/arch.h>
 #include <arch/asm.h>
+#include <arch/ucb.h>
+#include <arch/mm.h>
 #include <version.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <printf.h>
 #include <macros.h>
@@ -39,8 +41,5 @@
 #include <halt.h>
 #include <inflate.h>
-#include <arch/_components.h>
-
-#define KA2PA(x)  (((uintptr_t) (x)) - UINT64_C(0xffff800000000000))
-#define PA2KA(x)  (((uintptr_t) (x)) + UINT64_C(0xffff800000000000))
+#include "../../components.h"
 
 static bootinfo_t bootinfo;
@@ -50,25 +49,39 @@
 	version_print();
 	
+	bootinfo.htif_frame = ((uintptr_t) &htif_page) >> PAGE_WIDTH;
+	bootinfo.pt_frame = ((uintptr_t) &pt_page) >> PAGE_WIDTH;
+	
+	bootinfo.ucbinfo.tohost =
+	    (volatile uint64_t *) PA2KA((uintptr_t) &tohost);
+	bootinfo.ucbinfo.fromhost =
+	    (volatile uint64_t *) PA2KA((uintptr_t) &fromhost);
+	
 	// FIXME TODO: read from device tree
-	bootinfo.memmap.total = 1024 * 1024 * 1024;
-	bootinfo.memmap.cnt = 0;
+	bootinfo.physmem_start = PHYSMEM_START;
+	bootinfo.memmap.total = PHYSMEM_SIZE;
+	bootinfo.memmap.cnt = 1;
+	bootinfo.memmap.zones[0].start = (void *) PHYSMEM_START;
+	bootinfo.memmap.zones[0].size = PHYSMEM_SIZE;
 	
-	printf("\nMemory statistics (total %lu MB)\n\n", bootinfo.memmap.total >> 20);
+	printf("\nMemory statistics (total %lu MB, starting at %p)\n\n",
+	    bootinfo.memmap.total >> 20, (void *) bootinfo.physmem_start);
 	printf(" %p: boot info structure\n", &bootinfo);
 	
-	uintptr_t top = 0;
+	uintptr_t top = BOOT_OFFSET;
 	
 	for (size_t i = 0; i < COMPONENTS; i++) {
-		printf(" %p: %s image (%zu/%zu bytes)\n", components[i].start,
+		printf(" %p: %s image (%zu/%zu bytes)\n", components[i].addr,
 		    components[i].name, components[i].inflated,
 		    components[i].size);
 		
-		uintptr_t tail = (uintptr_t) components[i].start +
+		uintptr_t tail = (uintptr_t) components[i].addr +
 		    components[i].size;
-		if (tail > top)
-			top = tail;
+		if (tail > top) {
+			printf("\n%s: Image too large to fit (%p >= %p), halting.\n",
+			    components[i].name, (void *) tail, (void *) top);
+			halt();
+		}
 	}
 	
-	top = ALIGN_UP(top, PAGE_SIZE);
 	printf(" %p: inflate area\n", (void *) top);
 	
@@ -92,5 +105,5 @@
 			bootinfo.taskmap.cnt++;
 		} else
-			kernel_entry = (void *) top;
+			kernel_entry = (void *) PA2KA(top);
 		
 		dest[i] = (void *) top;
@@ -101,5 +114,5 @@
 	printf(" %p: kernel entry point\n", kernel_entry);
 	
-	if (top >= bootinfo.memmap.total) {
+	if (top >= bootinfo.physmem_start + bootinfo.memmap.total) {
 		printf("Not enough physical memory available.\n");
 		printf("The boot image is too large. Halting.\n");
@@ -112,5 +125,5 @@
 		printf("%s ", components[i - 1].name);
 		
-		int err = inflate(components[i - 1].start, components[i - 1].size,
+		int err = inflate(components[i - 1].addr, components[i - 1].size,
 		    dest[i - 1], components[i - 1].inflated);
 		
@@ -125,4 +138,4 @@
 	
 	printf("Booting the kernel...\n");
-	jump_to_kernel(kernel_entry, PA2KA(&bootinfo));
+	jump_to_kernel(PA2KA(&bootinfo));
 }
Index: boot/arch/riscv64/src/putchar.c
===================================================================
--- boot/arch/riscv64/src/putchar.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/src/putchar.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,5 +27,5 @@
  */
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <arch/arch.h>
 #include <putchar.h>
Index: boot/arch/riscv64/src/ucb.c
===================================================================
--- boot/arch/riscv64/src/ucb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/riscv64/src/ucb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,4 +31,16 @@
 #include <macros.h>
 
+volatile uint64_t tohost __attribute__((section(".htif")));
+volatile uint64_t fromhost __attribute__((section(".htif")));
+
+static void poll_fromhost()
+{
+	uint64_t val = fromhost;
+	if (!val)
+		return;
+	
+	fromhost = 0;
+}
+
 void htif_cmd(uint8_t device, uint8_t cmd, uint64_t payload)
 {
@@ -36,12 +48,8 @@
 	    (((uint64_t) cmd) << 48) |
 	    (payload & UINT64_C(0xffffffffffff));
-	uint64_t retval;
 	
-	do {
-		asm volatile (
-			"csrrw %[retval], " STRING(CSR_MTOHOST) ", %[val]\n"
-			: [retval] "=r" (retval)
-			: [val] "r" (val)
-		);
-	} while (retval != 0);
+	while (tohost)
+		poll_fromhost();
+	
+	tohost = val;
 }
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -57,5 +57,6 @@
 	arch/$(BARCH)/src/main.c \
 	arch/$(BARCH)/src/ofw.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	genarch/src/ofw.c \
 	genarch/src/ofw_tree.c \
@@ -68,2 +69,4 @@
 	generic/src/version.c \
 	generic/src/inflate.c
+
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/sparc64/_link.ld.in
===================================================================
--- boot/arch/sparc64/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -15,5 +15,5 @@
 		*(.bss);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-[[COMPONENTS]]
+		*(.components);
 	}
 	
Index: boot/arch/sparc64/include/asm.h
===================================================================
--- boot/arch/sparc64/include/asm.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/include/asm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,5 @@
 #define BOOT_sparc64_ASM_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern void jump_to_kernel(uintptr_t physmem_start, bootinfo_t *bootinfo,
Index: boot/arch/sparc64/include/main.h
===================================================================
--- boot/arch/sparc64/include/main.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/include/main.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_sparc64_MAIN_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <balloc.h>
 #include <genarch/ofw_tree.h>
Index: boot/arch/sparc64/include/ofw.h
===================================================================
--- boot/arch/sparc64/include/ofw.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/include/ofw.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_sparc64_OFW_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 #define OFW_ADDRESS_CELLS  2
Index: boot/arch/sparc64/include/types.h
===================================================================
--- boot/arch/sparc64/include/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/include/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,6 @@
 #define BOOT_sparc64_TYPES_H_
 
+#include <arch/common.h>
+
 #define TASKMAP_MAX_RECORDS        32
 #define BOOTINFO_TASK_NAME_BUFLEN  32
Index: boot/arch/sparc64/src/main.c
===================================================================
--- boot/arch/sparc64/src/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/src/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -32,5 +32,4 @@
 #include <arch/asm.h>
 #include <arch/ofw.h>
-#include <arch/_components.h>
 #include <genarch/ofw.h>
 #include <genarch/ofw_tree.h>
@@ -44,4 +43,5 @@
 #include <errno.h>
 #include <inflate.h>
+#include "../../components.h"
 
 /* The lowest ID (read from the VER register) of some US3 CPU model */
@@ -220,6 +220,6 @@
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
-		    ofw_translate(components[i].start), components[i].name,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].addr,
+		    ofw_translate(components[i].addr), components[i].name,
 		    components[i].inflated, components[i].size);
 	
@@ -267,5 +267,5 @@
 		    ALIGN_UP(components[i - 1].inflated, PAGE_SIZE), -1);
 		
-		int err = inflate(components[i - 1].start, components[i - 1].size,
+		int err = inflate(components[i - 1].addr, components[i - 1].size,
 		    dest[i - 1], components[i - 1].inflated);
 		
